function model=buildmodel(func,X,Y,delta,gam,mu,kernel,par,Xt)
% A function build the model and fold the different variables into it
%
% >> model=buildmodel(func,X,Y,delta)
% >> model=buildmodel(func,X,Y,delta,gam)
% >> model=buildmodel(func,X,Y,delta,gam,mu)
%
% Input
% func is the name of the model function
% X is a matrix n colums and d rows
% Y is a vector of n elements
% delta is a vector of n elements (0-1 values)
% gam is a scalar
% mu is a scalar
%
% Output
% model is a grouped variable include fields func,X,Y,delta,gam,mu

model.func=func;
model.X=X;
model.Y=Y;
model.delta=delta;
if nargin>4 
    model.gam=gam; 
end
if nargin>5
    model.mu=mu; 
end

if nargin>6
    model.kernel=kernel;
    model.par=par;
    model.Xt=Xt;
end