clear;
fprintf('\n');
disp('--------------------------------START--------------------------------');
disp('This demo shows how we can use this program.');

dataset='sorliedataorig'; % Dataset
func='minlip_kernelly'; % Model function
tunemethod='linesearch'; % Tune method
tunepar={-20,20,1,0.5}; % Tune parameters (serach range/initial values)
testmethod='CVk'; % Test method
testpar={3}; % Test parameters

% Start
tic

% Load the selected database
load(dataset);
model=buildmodel(func,X,Y,delta);

n=size(X,1);
ntrain=ceil(n/3*2);
ntest=n-ntrain;

% Seperate it into train set and test set
indtrain=ntest+1:n;
indtest=1:ntest;
[trainmodel,testmodel]=seperatemodel(model,indtrain,indtest);

% Change the signs if needed
if strcmp(func,'model2p') || strcmp(func,'minlipp')
    [trainmodel.X, testmodel.X]=changesign(trainmodel,testmodel.X);
end


trainmodel2=trainmodel;
trainmodel2.func='minlip';
testmodel2=testmodel;
trainmodel2.gam=tune(trainmodel2,tunemethod,tunepar,'CV',testpar);
ctest2=cindex(testmodel2.X*feval('minlip',trainmodel2),testmodel2.Y,testmodel2.delta)

% Tune the trainmodel
trainmodel.gam=tune(trainmodel,tunemethod,tunepar,testmethod,testpar);
% Get w based on training set using the tuned parameters
trainmodel.kernel='lin_kernel';
trainmodel.par=[];
trainmodel.Xt=testmodel.X;
[a,u]=feval(func,trainmodel);
ctest=cindex(u,testmodel.Y,testmodel.delta)
% 
% w=feval(func,trainmodel);
% 
% %Calculate the c-index on both sets
% ctest=cindex(testmodel.X*w,testmodel.Y,testmodel.delta)
% ctrain=cindex(trainmodel.X*w,trainmodel.Y,trainmodel.delta)
% lrtest=getlogrank(testmodel.Y,testmodel.delta,testmodel.X*w)
% lrtrain=getlogrank(trainmodel.Y,trainmodel.delta,trainmodel.X*w)
% hrtest=gethr(testmodel.Y,testmodel.delta,-testmodel.X*w)
% hrtrain=gethr(trainmodel.Y,trainmodel.delta,-trainmodel.X*w)
disp('Time cost:')
toc

disp('---------------------------------END---------------------------------');
fprintf('\n');