function [trainx2, testx2]=standardise(trainx, testx,vector)

% Standardise the given sets trainx and testx, such that the trainingset 
% has zero main and unit standard deviation, for the columns given in vector.
%
% Copyright (c) 2010,  KULeuven-ESAT-SCD

m=mean(trainx);
s=std(trainx);

ind=find(s==0);

trainx2=trainx;
testx2=testx;

trainn=size(trainx,1);testn=size(testx,1);

for i=1:length(vector)
    trainx2(:,vector(i))=(trainx(:,vector(i))-ones(trainn,1)*m(vector(i)))./s(vector(i));
    if ~isempty(testx)
    testx2(:,vector(i))=(testx(:,vector(i))-ones(testn,1)*m(vector(i)))./s(vector(i));
    end
end

ind=find(s==0);

trainx2(:,ind)=trainx(:,ind);
testx2(:,ind)=testx(:,ind);
