clear;
fprintf('\n');
numcores=12;
if numcores>1
    if matlabpool('size')>0
        matlabpool close;
    end
    eval(['matlabpool local ' num2str(numcores)]);
end
disp('--------------------------------START--------------------------------');
disp('This demo shows the relationship between dim and c-index on artificial data set');

dataset='sim2'; % Dataset
func='APTER'; % Model function
func2='APTER';
func3='minlip';
func4='minlipp';
tunemethod='linesearch'; % Tune method
tunepar={-10,5,0.5,0.4}; % Tune parameters (serach range/initial values)
testmethod='CV'; % Test method
testpar={3}; % Test parameters

% Start
tic

% Load the selected database
n=1000;
kk=[100,250,500,750,1000,2500,5000,7500,10000,12500,15000,17500,20000];
parfor i=1:length(kk)
    for nr=1:5
    k=kk(i);
    [X,Y,delta]=artificialData(n,k);
    trainmodel=buildmodel(func,X,Y,delta);
    [X,Y,delta]=artificialData(n,k);
    testmodel=buildmodel(func,X,Y,delta);
    
    trainmodel2=trainmodel;
    testmodel2=testmodel;
    trainmodel3=trainmodel;
    testmodel3=testmodel;
    trainmodel4=trainmodel;
    testmodel4=testmodel;
    
    
    trainmodel.X=[trainmodel.X,-trainmodel.X];
    testmodel.X=[testmodel.X,-testmodel.X];
    
    bestpars=tune(trainmodel,tunemethod,tunepar,testmethod,testpar);
    gams(i)=bestpars(1);
    trainmodel.gam=bestpars(1);
    
    w=feval(func,trainmodel);
    
    %Calculate the c-index on both sets
    ctest(i,nr)=cindex(testmodel.X*w,testmodel.Y,testmodel.delta);
    ctrain(i)=cindex(trainmodel.X*w,trainmodel.Y,trainmodel.delta);
    lrtest(i)=getlogrank(testmodel.Y,testmodel.delta,testmodel.X*w);
    lrtrain(i)=getlogrank(trainmodel.Y,trainmodel.delta,trainmodel.X*w);
    hrtest(i)=gethr(testmodel.Y,testmodel.delta,-testmodel.X*w);
    hrtrain(i)=gethr(trainmodel.Y,trainmodel.delta,-trainmodel.X*w);
    
    
    [trainmodel2.X, testmodel2.X]=changesign(trainmodel2,testmodel2.X);
    trainmodel2.func=func2;
    testmodel2.func=func2;
    
    bestpars=tune(trainmodel2,tunemethod,tunepar,testmethod,testpar);
    gams2(i)=bestpars(1);
    trainmodel2.gam=bestpars(1);
    
    w=feval(func2,trainmodel2);
    
    %Calculate the c-index on both sets
    ctest2(i,nr)=cindex(testmodel2.X*w,testmodel2.Y,testmodel2.delta);
    ctrain2(i)=cindex(trainmodel2.X*w,trainmodel2.Y,trainmodel2.delta);
    lrtest2(i)=getlogrank(testmodel2.Y,testmodel2.delta,testmodel2.X*w);
    lrtrain2(i)=getlogrank(trainmodel2.Y,trainmodel2.delta,trainmodel2.X*w);
    hrtest2(i)=gethr(testmodel2.Y,testmodel2.delta,-testmodel2.X*w);
    hrtrain2(i)=gethr(trainmodel2.Y,trainmodel2.delta,-trainmodel2.X*w);
    
    
    
    trainmodel3.func=func3;
    testmodel3.func=func3;
    
    bestpars=tune(trainmodel3,tunemethod,tunepar,testmethod,testpar);
    gams3(i)=bestpars(1);
    trainmodel3.gam=bestpars(1);
    
    w=feval(func3,trainmodel3);
    
    %Calculate the c-index on both sets
    ctest3(i,nr)=cindex(testmodel3.X*w,testmodel3.Y,testmodel3.delta);
    ctrain3(i)=cindex(trainmodel3.X*w,trainmodel3.Y,trainmodel3.delta);
    lrtest3(i)=getlogrank(testmodel3.Y,testmodel3.delta,testmodel3.X*w);
    lrtrain3(i)=getlogrank(trainmodel3.Y,trainmodel3.delta,trainmodel3.X*w);
    hrtest3(i)=gethr(testmodel3.Y,testmodel3.delta,-testmodel3.X*w);
    hrtrain3(i)=gethr(trainmodel3.Y,trainmodel3.delta,-trainmodel3.X*w);
    
    
    [trainmodel4.X, testmodel4.X]=changesign(trainmodel4,testmodel4.X);
    trainmodel4.func=func4;
    testmodel4.func=func4;
    
    bestpars=tune(trainmodel4,tunemethod,tunepar,testmethod,testpar);
    gams4(i)=bestpars(1);
    trainmodel4.gam=bestpars(1);
    
    w=feval(func4,trainmodel4);
    
    %Calculate the c-index on both sets
    ctest4(i,nr)=cindex(testmodel4.X*w,testmodel4.Y,testmodel4.delta);
    ctrain4(i)=cindex(trainmodel4.X*w,trainmodel4.Y,trainmodel4.delta);
    lrtest4(i)=getlogrank(testmodel4.Y,testmodel4.delta,testmodel4.X*w);
    lrtrain4(i)=getlogrank(trainmodel4.Y,trainmodel4.delta,trainmodel4.X*w);
    hrtest4(i)=gethr(testmodel4.Y,testmodel4.delta,-testmodel4.X*w);
    hrtrain4(i)=gethr(trainmodel4.Y,trainmodel4.delta,-trainmodel4.X*w);
    
    fprintf('...%s\n',num2str(i));
    end
end

disp('Time cost:')
ct=toc

figure;
boxplot([ctest']);
figure;
boxplot([ctest2']);
figure;
boxplot([ctest3']);
figure;
boxplot([ctest4']);


save n1000-r5;

disp('---------------------------------END---------------------------------');
if matlabpool('size')>0
    matlabpool close;
end
fprintf('\n');