clear;
fprintf('\n');
% numcores=12;
% if numcores>1
%     if matlabpool('size')>0
%         matlabpool close;
%     end
%     eval(['matlabpool local ' num2str(numcores)]);
% end
disp('--------------------------------START--------------------------------');
disp('This demo shows the relationship between dim and c-index on artificial data set');

dataset='sim2'; % Dataset
func='minlip_kernelly'; % Model function
tunemethod='linesearch'; % Tune method
tunepar={-20,10,1,0.5}; % Tune parameters (serach range/initial values)
testmethod='CVk'; % Test method
testpar={3}; % Test parameters

% Start
tic

% Load the selected database
n=100;
kk=[100,250,500,750,1000,2500,5000,7500,10000,12500,15000,17500,20000];
for i=1:length(kk)
    for nr=1:5
    k=kk(i);
    [X,Y,delta]=artificialData(n,k);
    trainmodel=buildmodel(func,X,Y,delta,0,0,'lin_kernel',[],0);
    [X,Y,delta]=artificialData(n,k);
    testmodel=buildmodel(func,X,Y,delta);
    
    bestpars=tune(trainmodel,tunemethod,tunepar,testmethod,testpar);
    gams(i,nr)=bestpars(1);
    trainmodel.gam=bestpars(1);
%     pars(i,nr)=bestpars(2);
    trainmodel.kernel='lin_kernel';
%     trainmodel.par=[bestpars(2)];
    trainmodel.Xt=testmodel.X;
    [a,u]=feval(func,trainmodel);
    ctest(i,nr)=cindex(u,testmodel.Y,testmodel.delta);

    fprintf('...%s\n',num2str(i));
    end
end

disp('Time cost:')
ct=toc

figure;
boxplot([ctest']);

disp('---------------------------------END---------------------------------');
% if matlabpool('size')>0
%     matlabpool close;
% end
fprintf('\n');